//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
#include "Unit4.h"
#include <memory>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SHDocVw_OCX"
#pragma link "CustomTransformer"
#pragma link "TetraTree"
#pragma link "MemoTransformer"
#pragma resource "*.dfm"
TForm1 *Form1;



//---------------------------------------------------------------------------
void LoadHtmlFromStream(TCppWebBrowser* pCppWebBrowser,
  TMemoryStream* pMemStream)
{
  if(pMemStream && pCppWebBrowser)
  {
    IPersistStreamInit* pPSI;
    pMemStream->Seek(0, 0);
    if(!pCppWebBrowser->Document)
    {
      pCppWebBrowser->Navigate(WideString("about:blank"));
      while(!pCppWebBrowser->Document)
        Application->ProcessMessages();
    }
    TStreamAdapter* pStreamAdapter = new TStreamAdapter(
    pMemStream, soReference);
    if(SUCCEEDED(pCppWebBrowser->Document->QueryInterface(
    IID_IPersistStreamInit, (LPVOID*)&pPSI)))
    pPSI->Load(*pStreamAdapter);
  }
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
 : TForm(Owner),
   m_bAllowNavigate(m_bAllowNavigate)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  m_bAllowNavigate = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
  TStringList* inistr = new TStringList;
  try
  {
    if (FileExists(ChangeFileExt(Application->ExeName, ".ini")) )
    {
      inistr->LoadFromFile(ChangeFileExt(Application->ExeName, ".ini"));
      DataModule4->Parse(inistr->Text);
    }
  }
  __finally {
    delete inistr;
  }
  SetProject(DataModule4->Project);
  OpenFile(DataModule4->InputFile);
  Top = DataModule4->Top;
  Left = DataModule4->Left;
  Height = DataModule4->Height;
  Width = DataModule4->Width;
  SetProject("Text2Html.ttp");
  ComboBox1->ItemIndex = TextTreeViewTransformer1->TreeType;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  if( WindowState == wsNormal )
  {
    DataModule4->Top = Top;
    DataModule4->Left = Left;
    DataModule4->Height = Height;
    DataModule4->Width = Width;
  }

  DataModule4->WriteIni();
  ComboBox1->OnChange = NULL;
  MemoTextTransformer1->Free();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SetProject(AnsiString xasProject)
{
  TextTreeViewTransformer1->Project = xasProject;
  MemoTextTransformer1->Project = xasProject;
  Form2->TextFileN2NTransformer1->Project = xasProject;
  Form3->TextFileN21Transformer1->Project = xasProject;
  StatusBar1->SimpleText = xasProject;
  PageControl1->ActivePage = ts_Edit;
  DataModule4->Project = xasProject;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mi_OpenFileClick(TObject *Sender)
{
  OpenDialog1->InitialDir = ExtractFilePath(Application->ExeName);

  if(OpenDialog1->Execute())
    OpenFile(OpenDialog1->FileName);
}
//---------------------------------------------------------------------------
void TForm1::OpenFile(AnsiString xFilename )
{
  MemoTextTransformer1->Input->Lines->LoadFromFile(xFilename);
  PageControl1->ActivePage = ts_Edit;
  DataModule4->InputFile = xFilename;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mi_SaveFileClick(TObject *Sender)
{
  OpenDialog1->DefaultExt = "HTML";
  OpenDialog1->FileName = "*.html";
  if(SaveDialog1->Execute())
     Memo2->Lines->SaveToFile(SaveDialog1->FileName);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mi_OpenProjectClick(TObject *Sender)
{
  TCursor Cursor = Screen->Cursor;
  Screen->Cursor = crHourGlass;

  OpenDialog2->InitialDir = ExtractFilePath(Application->ExeName);

  if(OpenDialog2->Execute())
    SetProject(OpenDialog2->FileName);

  Screen->Cursor = Cursor;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PageControl1Change(TObject *Sender)
{
  TCursor Cursor = Screen->Cursor;
  Screen->Cursor = crHourGlass;

  std::auto_ptr<TMemoryStream> apStream(new TMemoryStream);
  std::auto_ptr<TStringList> apsl(new TStringList);

  if( PageControl1->ActivePage == ts_View ||
      PageControl1->ActivePage == ts_Html)
  {
    Execute(MemoTextTransformer1);

    apsl->Text = Memo2->Text;
    m_bAllowNavigate = true;
    apsl->SaveToStream(apStream.get());
    LoadHtmlFromStream(CppWebBrowser1, apStream.get());
    m_bAllowNavigate = false;
  }
  else
  if( PageControl1->ActivePage == ts_Tree)
    Execute(TextTreeViewTransformer1);

  Screen->Cursor = Cursor;
}
//---------------------------------------------------------------------------
bool __fastcall TForm1::Execute(TCustomTextTransformer* xpTransformer)
{
  if(!xpTransformer->SetActive())
  {
    ShowMessage(xpTransformer->Project + " cannot be activated!");
    Screen->Cursor = Cursor;
    return false;
  }

  bool bOk = true;
  if(xpTransformer->Modified)
     bOk = xpTransformer->Execute();

  return bOk;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MemoTextTransformer1Exception(TObject *Sender,
      AnsiString xasWhat)
{
  Application->MessageBox(xasWhat.c_str(), "Exception");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MemoTextTransformer1ParserMessage(TObject *Sender,
      AnsiString xasWhat, DWORD xlwLastPosition, DWORD xlwPosition,
      const AnsiString xasProduction, const AnsiString xasSymbol,
      eParserMessage xeMessageType, DWORD xlw)
{
  Application->MessageBox(xasWhat.c_str(), "ParserMessage");
  PageControl1->ActivePage = ts_Edit;
  Memo1->SetFocus();
  Memo1->SelStart = xlwLastPosition;
  Memo1->SelLength = xlwPosition - xlwLastPosition;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mi_FileTransformerN2NClick(TObject *Sender)
{
  if(!Form2->TextFileN2NTransformer1->SetActive())
  {
    ShowMessage(Form2->TextFileN2NTransformer1->Project + " cannot be activated!");
    Screen->Cursor = Cursor;
    return;
  }

  Form2->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mi_FileTransformerN21Click(TObject *Sender)
{
  if(!Form3->TextFileN21Transformer1->SetActive())
  {
    ShowMessage(Form3->TextFileN21Transformer1->Project + " cannot be activated!");
    Screen->Cursor = Cursor;
    return;
  }

  Form3->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CppWebBrowser1BeforeNavigate2(TObject *Sender,
      LPDISPATCH pDisp, Variant *URL, Variant *Flags,
      Variant *TargetFrameName, Variant *PostData, Variant *Headers,
      VARIANT_BOOL *Cancel)
{
  *Cancel = !m_bAllowNavigate;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::pmi_ExpandClick(TObject *Sender)
{
  if(TreeView1->Selected)
     TreeView1->Selected->Expand(true);
  TreeView1->TopItem = TreeView1->Selected;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::pmi_CollapseClick(TObject *Sender)
{
  if(TreeView1->Selected)
     TreeView1->Selected->Collapse(true);
  TreeView1->TopItem = TreeView1->Selected;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TreeView1Click(TObject *Sender)
{
  TTetraNode* pn = dynamic_cast<TTetraNode*>(TreeView1->Selected);
  if(pn)
   edt_Token->Text = pn->RecognizedText();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
  if(TextTreeViewTransformer1->TreeType != ComboBox1->ItemIndex)
  {
    TextTreeViewTransformer1->TreeType = (eTreeType) ComboBox1->ItemIndex;
    Execute(TextTreeViewTransformer1);
  }
}
//---------------------------------------------------------------------------

