//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

//#include <Classes.hpp>
//#include <SysUtils.hpp>
#include <StrUtils.hpp>
#include "Inienums.hpp"

#include "Unit4.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CustomTransformer"
#pragma link "StringTransformer"
#pragma resource "*.dfm"
TDataModule4 *DataModule4;
//---------------------------------------------------------------------------
__fastcall TDataModule4::TDataModule4(TComponent* Owner)
        : TDataModule(Owner),
          LastSection(NULL),
          LastEntry(NULL),
          Stack(NULL),
          Ini(NULL)
{
}
//---------------------------------------------------------------------------

void __fastcall TDataModule4::DataModuleCreate(TObject *Sender)
{
  Stack = new TStack;
  Ini = new TIni;
}
//---------------------------------------------------------------------------

void __fastcall TDataModule4::DataModuleDestroy(TObject *Sender)
{
  delete Stack;
  delete Ini;
  Ini = NULL;
}
//---------------------------------------------------------------------------
AnsiString TDataModule4::GetProject()
{
  if ( Ini != NULL )
    return Ini->GetValue("FILES", "PROJECT", "Text2Html.ttp");
   else
    return AnsiString();
}
//---------------------------------------------------------------------------
AnsiString TDataModule4::GetInputFile()
{
  if ( Ini != NULL )
    return Ini->GetValue("FILES", "INPUT", ".\\Text2Html_sources\\Help.txt");
   else
    return AnsiString();
}
//---------------------------------------------------------------------------
int TDataModule4::GetTop()
{
  if ( Ini != NULL )
    return StrToInt(Ini->GetValue("LAYOUT", "TOP", "90"));
   else
    return StrToInt(90);
}
//---------------------------------------------------------------------------
int TDataModule4::GetLeft()
{
  if ( Ini != NULL )
     return StrToInt(Ini->GetValue("LAYOUT", "LEFT", "170"));
   else
    return StrToInt(170);
}
//---------------------------------------------------------------------------
int TDataModule4::GetWidth()
{
  if ( Ini != NULL )
     return StrToInt(Ini->GetValue("LAYOUT", "WIDTH", "590"));
   else
    return StrToInt(590);
}
//---------------------------------------------------------------------------
int TDataModule4::GetHeight()
{
  if ( Ini != NULL )
    return StrToInt(Ini->GetValue("LAYOUT", "HEIGHT", "390"));
   else
    return StrToInt(390);
}
//---------------------------------------------------------------------------
void TDataModule4::SetProject(AnsiString xs)
{
  if ( Ini != NULL )
     Ini->SetValue("FILES", "PROJECT", xs);
}
//---------------------------------------------------------------------------
void TDataModule4::SetInputFile(AnsiString xs)
{
  if ( Ini != NULL )
     Ini->SetValue("FILES", "INPUT", xs);
}
//---------------------------------------------------------------------------
void TDataModule4::SetTop(int xi)
{
  if ( Ini != NULL )
     Ini->SetValue("LAYOUT", "TOP", IntToStr(xi));
}
//---------------------------------------------------------------------------
void TDataModule4::SetLeft(int xi)
{
  if ( Ini != NULL )
     Ini->SetValue("LAYOUT", "LEFT", IntToStr(xi));
}
//---------------------------------------------------------------------------
void TDataModule4::SetWidth(int xi)
{
  if ( Ini != NULL )
     Ini->SetValue("LAYOUT", "WIDTH", IntToStr(xi));
}
//---------------------------------------------------------------------------
void TDataModule4::SetHeight(int xi)
{
  if ( Ini != NULL )
    Ini->SetValue("LAYOUT", "HEIGHT", IntToStr(xi));
}
//---------------------------------------------------------------------------
AnsiString TDataModule4::Recognized(unsigned int xlwRecognizedBegin, unsigned int xlwRecognizedEnd)
{
  return MidStr(Input, xlwRecognizedBegin, xlwRecognizedEnd - xlwRecognizedBegin);
}
//---------------------------------------------------------------------------
void TDataModule4::Parse(const AnsiString xasInput)
{
  Input = xasInput;
  StringTransformer1->TransformToTree(Input);
}
//---------------------------------------------------------------------------
void TDataModule4::WriteIni()
{
  if ( Ini != NULL )
     Ini->WriteIni();
}
//---------------------------------------------------------------------------
void __fastcall TDataModule4::StringTransformer1EnterProduction(
      TObject *Sender, const AnsiString xasName, int xeSymno)
{
  Stack->Push((void*)xeSymno);
}
//---------------------------------------------------------------------------
void __fastcall TDataModule4::StringTransformer1ExitProduction(
      TObject *Sender)
{
  EProduction e = (EProduction) Stack->Peek();
  switch(e)
  {
    case pdSection:
    LastSection = NULL;
    break;
    case pdEntry:
    LastEntry = NULL;
    break;
  }

  Stack->Pop();
}
//---------------------------------------------------------------------------
void __fastcall TDataModule4::StringTransformer1AcceptToken(
      TObject *Sender, const AnsiString xasName, int xeSymno,
      DWORD xlwIgnoredBegin, DWORD xlwRecognizedBegin,
      DWORD xlwRecognizedEnd, bool xbIsSkip)
{
  EProduction e = (EProduction) Stack->Peek();
  switch( EToken(xeSymno) )
  {
    case tkID :
    {
      switch( e )
      {
        case pdSection:
        LastSection = Ini->NewSection( Recognized( xlwRecognizedBegin, xlwRecognizedEnd));
        break;
        case pdEntry:
        if (LastSection != NULL )
           LastEntry = LastSection->NewEntry( Recognized( xlwRecognizedBegin, xlwRecognizedEnd));
        break;
      };
    }
    break;
    case tkROL:
    {
      if( LastEntry != NULL )
         LastEntry->Value =
             Recognized( xlwRecognizedBegin, xlwRecognizedEnd);
    }
    break;
  }
}
//---------------------------------------------------------------------------
void __fastcall TDataModule4::StringTransformer1Exception(TObject *Sender,
      AnsiString xasWhat)
{
  Application->MessageBox(xasWhat.c_str(), "Exception");
}
//---------------------------------------------------------------------------
void __fastcall TDataModule4::StringTransformer1ParserMessage(
      TObject *Sender, AnsiString xasWhat, DWORD xlwLastPosition,
      DWORD xlwPosition, const AnsiString xasProduction,
      const AnsiString xasSymbol, eParserMessage xeMessageType, DWORD xlw)
{
  Application->MessageBox(xasWhat.c_str(), "ParserMessage");
}
//---------------------------------------------------------------------------
