//---------------------------------------------------------------------------

#ifndef Unit4H
#define Unit4H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "CustomTransformer.hpp"
#include "StringTransformer.hpp"
#include "TetraTypes.hpp"
#include "Ini.hpp"

//---------------------------------------------------------------------------
class TDataModule4 : public TDataModule
{
__published:	// Von der IDE verwaltete Komponenten
  TStringTransformer *StringTransformer1;
  void __fastcall DataModuleCreate(TObject *Sender);
  void __fastcall DataModuleDestroy(TObject *Sender);
  void __fastcall StringTransformer1EnterProduction(TObject *Sender,
    const AnsiString xasName, int xeSymno);
  void __fastcall StringTransformer1ExitProduction(TObject *Sender);
  void __fastcall StringTransformer1AcceptToken(TObject *Sender,
    const AnsiString xasName, int xeSymno, DWORD xlwIgnoredBegin,
    DWORD xlwRecognizedBegin, DWORD xlwRecognizedEnd, bool xbIsSkip);
  void __fastcall StringTransformer1Exception(TObject *Sender,
    AnsiString xasWhat);
  void __fastcall StringTransformer1ParserMessage(TObject *Sender,
    AnsiString xasWhat, DWORD xlwLastPosition, DWORD xlwPosition,
    const AnsiString xasProduction, const AnsiString xasSymbol,
    eParserMessage xeMessageType, DWORD xlw);
private:	// Anwender-Deklarationen
    AnsiString Input;
    TStack* Stack;
    TIni* Ini;
    TSection* LastSection;
    TEntry* LastEntry;

    AnsiString GetProject();
    AnsiString GetInputFile();
    int GetTop();
    int GetLeft();
    int GetWidth();
    int GetHeight();
    void SetProject(AnsiString xs);
    void SetInputFile(AnsiString xs);
    void SetTop(int xi);
    void SetLeft(int xi);
    void SetWidth(int xi);
    void SetHeight(int xi);

    AnsiString Recognized(unsigned intxlwRecognizedBegin, unsigned intxlwRecognizedEnd);

public:		// Anwender-Deklarationen
        __fastcall TDataModule4(TComponent* Owner);

    void Parse(const AnsiString xasInput);
    void WriteIni();

  __property AnsiString Project = { read = GetProject, write = SetProject};
  __property AnsiString InputFile = { read = GetInputFile, write = SetInputFile};
  __property int Top = {read = GetTop, write = SetTop};
  __property int Left = {read = GetLeft, write = SetLeft};
  __property int Width = {read = GetWidth, write = SetWidth};
  __property int Height = {read = GetHeight, write = SetHeight};

};
//---------------------------------------------------------------------------
extern PACKAGE TDataModule4 *DataModule4;
//---------------------------------------------------------------------------
#endif
